#ifndef ERROR_H
#define ERROR_H

#include <iostream>
#include "common.h"
#include "input.h"

#define BUFFER_LENGTH 256

#define LOG_DEBUG(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logDebug(errorBuffer);}
#define LOG_WARNING(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logWarning(errorBuffer);}
#define LOG_ERROR(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logError(errorBuffer);}
#define LOG_INFO(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logInfo(errorBuffer);}

namespace Librescue {
  void logError(const char* error);
  void logWarning(const char* warning);
  void logDebug(const char* debug);
  void logInfo(const char* info);
  void dumpBytes(const char* bytes, int size);
  void dumpBytes(const Byte* bytes, int size);
  void dumpBytes(const Bytes& bytes);
  void dumpBytes(Input& input);

  extern char errorBuffer[];
}

#endif
